' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
' Marks.BAS
' By ...
'
' Notes:
' For the purposes of read-ability, this program uses ONE (1) as the first
' element of all arrays rather than ZERO (0).
' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

'
' Declare data
'
REDIM StudentName(1) AS STRING  ' text name of student
REDIM Prog(1) AS INTEGER        ' mark score for programming assignments
REDIM Apps(1) AS INTEGER        ' mark score for applications assigments
REDIM TotalMark(1) AS INTEGER   ' total marks for both scores
DIM StudentCount AS INTEGER     ' number of students
DIM i AS INTEGER                ' generic index variable
DIM j AS INTEGER                ' generic index variable (sub usage)
DIM UserCmd AS STRING           ' user command for main loop
DIM FoundIndex AS INTEGER       ' index used to indicate found record
DIM InfoName AS STRING          ' var to represent single student name
DIM ProgScore AS INTEGER        ' var to represent single prog score
DIM AppsScore AS INTEGER        ' var to represent single apps score
DIM TotalScore AS INTEGER       ' var to represent single total
DIM SwitchCount AS INTEGER      ' # of switches made when sorting
DIM LongestName AS INTEGER      ' length of longest name (used in report)

'
' Begin program
'
LongestName = 0
CLS
PRINT "Please input the number of students: ";
INPUT StudentCount

WHILE StudentCount < 2
    PRINT "Invalid number of students, please re-enter: ";
    INPUT StudentCount
WEND

'
' Resize arrays to compensate for number of students
'
REDIM StudentName(StudentCount) AS STRING
REDIM Prog(StudentCount) AS INTEGER
REDIM Apps(StudentCount) AS INTEGER
REDIM TotalMark(StudentCount) AS INTEGER

'
' Get information about each student from user
'
FOR i = 1 TO StudentCount STEP 1

    '
    ' get name ... loops until valid name is gotten
    '
    DO
        PRINT "Enter name of student "; i; ": ";
        INPUT StudentName(i)

        ' make sure name is unique
        FOR j = 1 TO i - 1 STEP 1
            IF LCASE$(StudentName(i)) = LCASE$(StudentName(j)) THEN
                PRINT "Student by that name already exists!"
                StudentName(i) = "!" + StudentName(i)
            END IF
        NEXT j

        ' make sure name is valid
        IF LEN(StudentName(i)) < 2 THEN
            PRINT "Name has invalid length!"
            StudentName(i) = "!" + StudentName(i)
        END IF
   
        ' the loop will continue if the name begins with an exclaimation
        ' point which is added if a problem occured
    LOOP WHILE LEFT$(StudentName(i), 1) = "!"

    ' check against longest name
    IF LEN(StudentName(i)) > LongestName THEN
        LongestName = LEN(StudentName(i))
    END IF

    ' get mark score for programming assignments
    PRINT "Enter programming assignments score: ";
    INPUT Prog(i)

    ' get mark score for applications assignments
    PRINT "Enter applications assignments score: ";
    INPUT Apps(i)

    ' compute total score
    TotalMark(i) = Prog(i) + Apps(i)

NEXT i

' make sure the "LongestName" variable is at least 4 (for report header)
IF LongestName < 4 THEN
    LongestName = 4
END IF

PRINT "Data has been entered successfully"

'
' Main program loop.  Allows the user to enter a command
'
WHILE NOT UserCmd = "exit"

    ' get command from user
    PRINT
    PRINT "Command (type 'help' for list): ";
    INPUT UserCmd

    ' make sure the command is in lower-case
    UserCmd = LCASE$(UserCmd)

    
    SELECT CASE UserCmd
    ' - [ help ] ------------------------------------------------------------
    CASE "help"
        PRINT "Here is a list of commands you can use:"
        PRINT "help .......... brings up this list"
        PRINT "info .......... print information for specific student"
        PRINT "sort .......... sorts the list of students in ascending order"
        PRINT "report ........ displays a report for all students"
        PRINT "list .......... lists out all students' names"
        PRINT "exit .......... ends program"

    ' - [ info ] ------------------------------------------------------------
    CASE "info"
        PRINT "Input name of student: ";
        INPUT InfoName
        FoundIndex = 0

        FOR i = 1 TO StudentCount STEP 1
            IF StudentName(i) = InfoName THEN
                FoundIndex = i
            END IF
        NEXT i

        IF FoundIndex > 0 THEN
            PRINT StudentName(FoundIndex); " (record "; FoundIndex; "):"
            PRINT "    Programming Score  = "; Prog(FoundIndex)
            PRINT "    Applications Score = "; Apps(FoundIndex)
            PRINT " ---------------------   --------"
            PRINT "    Total Marks        = "; TotalMark(FoundIndex)
        ELSE
            PRINT "Couldn't find '"; InfoName; "' in records!"
        END IF

    ' - [ sort ] ------------------------------------------------------------
    '
    ' This uses a simple bubble sort which involves looping through the
    ' arrays the same amount as the size of the arrays (StudentCount)
    '
    CASE "sort"
        PRINT "Sorting ";

        ' reset count of switches
        SwitchCount = 0

        ' loop for multiple passes
        FOR i = 1 TO StudentCount - 1 STEP 1
           
            ' loop to switch
            FOR j = 1 TO StudentCount - 1 STEP 1

                ' need to switch these two
                IF StudentName(j) > StudentName(j + 1) THEN
                    ' show activity
                    PRINT ".";

                    ' increment number of switches
                    SwitchCount = SwitchCount + 1

                    ' fill temp variables
                    InfoName = StudentName(j)
                    ProgScore = Prog(j)
                    AppsScore = Apps(j)
                    TotalScore = TotalMark(j)

                    ' set previous element to next's data
                    StudentName(j) = StudentName(j + 1)
                    Prog(j) = Prog(j + 1)
                    Apps(j) = Apps(j + 1)
                    TotalMark(j) = TotalMark(j + 1)

                    ' set next's data to temp variables
                    StudentName(j + 1) = InfoName
                    Prog(j + 1) = ProgScore
                    Apps(j + 1) = AppsScore
                    TotalMark(j + 1) = TotalScore

                END IF ' if needed to switch

            NEXT j ' loop to switch

        NEXT i ' loop for multiple passes

        ' let user know the sorting has been finished
        PRINT " Done!"
        PRINT SwitchCount; " switches were made."

    ' - [ report ] ----------------------------------------------------------
    '
    ' This doesn't actually sort the original arrays, it simply outputs the
    ' students in ascending order using basic comparisons.
    '
    CASE "report"

        InfoName = ""  ' used as "base name"
        FoundIndex = 1

        '
        ' print report header
        '
        PRINT "Report on "; StudentCount; " students:"
        PRINT "Name ";
        FOR j = 1 TO LongestName - 1 STEP 1
            PRINT " ";
        NEXT j
        PRINT " Prog", "Apps", "Total Marks"
        FOR j = 1 TO LongestName + 4 STEP 1
            PRINT "-";
        NEXT j
        PRINT " ----", "----", "-----------"


        '
        ' only output the amount of students we have .. this prevents an
        ' infinite loop that might be introduced by bad logic for ascending
        ' order (shouldn't ever happen, but it's JUST IN CASE)
        '
        FOR i = 1 TO StudentCount STEP 1

            ' pick student based on base and info names
            FOR j = 1 TO StudentCount STEP 1

                ' this student must have a name further in the list than
                ' the base name, but higher than the current found index
                IF StudentName(j) < StudentName(FoundIndex) THEN
                    IF StudentName(j) > InfoName THEN
                        FoundIndex = j
                    END IF
                END IF

            NEXT j

            ' output information for found student
            PRINT StudentName(FoundIndex); " ";
            FOR j = 1 TO (LongestName + 3) - LEN(StudentName(FoundIndex)) STEP 1
                PRINT ".";
            NEXT j
            PRINT " "; Prog(FoundIndex), Apps(FoundIndex), TotalMark(FoundIndex)

            ' "increment" base name so we can move to the next name
            InfoName = StudentName(FoundIndex)

            ' reset found index to ANYTHING greater than info name
            FOR j = 1 TO StudentCount STEP 1
                IF StudentName(j) > InfoName THEN
                    FoundIndex = j
                END IF
            NEXT j

        NEXT i

        '
        ' print report footer
        '
        FOR j = 1 TO LongestName + 4 STEP 1
            PRINT "-";
        NEXT j
        PRINT " ----", "----", "-----------"
        PRINT "Report completed!"

    ' - [ list ] ------------------------------------------------------------
    CASE "list"

        PRINT "Listing all students: "
        FOR i = 1 TO StudentCount STEP 1
            PRINT i; ".) "; StudentName(i)
        NEXT i

    ' - [ exit ] ------------------------------------------------------------
    CASE "exit"
        PRINT "Exiting ... "
        ' nothing else needs to be done because the loop will break out
        ' now that 'UserCmd' is "exit"

    ' - [ unknown command! ] ------------------------------------------------
    CASE ELSE
        PRINT "Unknown command!  Type 'help' for command listing"
    END SELECT

WEND


