//file: book.cc

#include <iostream.h>
#include "bindery.h"

Date::Date()
: year   (0)
, month  (0)
, day    (0)
{
}

Date::Date(int newyear, int newmonth, int newday)
{
   Set(newyear, newmonth, newday);
}

Date::~Date()
{
   // nothing to destroy
}

void Date::GetInput(ostream &out, istream &in)
{
   out << "  Input year: ";
   in >> year;
   out << "  Input month: ";
   in >> month;
   out << "  Input day: ";
   in >> day;
}

void Date::Set(int newyear, int newmonth, int newday)
{
   year = newyear;
   month = newmonth;
   day = newday;
}

// returns true if this date is higher (further in the future) than 'd'
bool Date::higherThan(Date &d)
{
   if (year > d.year)
   {
      return true;
   }
   else if (year == d.year)
   {
      if (month > d.month)
      {
         return true;
      }
      else if (month == d.month)
      {
         if (day > d.day)
         {
            return true;
         }
      }
   }

   return false;
}

bool Date::lowerThan(Date &d)
{
   // re-use 'higher than' function
   return d.higherThan(*this);
}

ostream &operator<<(ostream &out, Date &src)
{
   return out << src.month << '/' << src.day << '/' << src.year;
}

Bindery::Bindery()
: book   (0)
, cost   (0.0)
{
   strcpy(condition, "");
}

Bindery::~Bindery()
{
   // nothing to destroy
}

void Bindery::Set(int newbook, char *newcondition, double newcost)
{
   book = newbook;
   strncpy(condition, newcondition, Max_Len);
   cost = newcost;
}

int Bindery::GetBook()
{
   return book;
}

char *Bindery::GetCondition()
{
   return (char*)condition;
}

double Bindery::GetCost()
{
   return cost;
}
