//file: book.h
//		implementation for book class

#ifndef Book_H_
#define Book_H_

class Book
{
friend ostream &operator<<(ostream &out, Book &src);

public:
   Book();
   Book(char *newtitle, char *newauthor, int newnumber);
   Book(Book &src);
   ~Book();

   void Init(char *newtitle, char *newauthor, int newnumber);
   void Print(ostream &out);
   Book &operator=(Book &src);
   int GetNumber();
   int GetStatus();
   void SetStatus(int newstatus);
   int GetOwner();
   void SetOwner(int newowner);
   void Write(ostream &out);

private:
   char *title;         // title of book
   char *author;        // author of book
   int number;          // book number (its unique identification)
   int status;          // status: -1 = at bindery, 0 = on shelf, 1 = checked out
   int owner;           // who has the book (card id of current owner)
};

ostream &operator<<(ostream &out, Book &src);

#endif