//file: card.cc
//       implementation for 'Card' class

#include <iostream.h>
#include "card.h"

Card :: Card()
: name   (NULL)
, phone  (NULL)
, id     (0)
, book   (0)
{
}

Card :: Card(char *newname, char *newphone, int newid)
: name   (NULL)
, phone  (NULL)
, id     (0)
, book   (0)
{
   Init(newname, newphone, newid);
}

Card :: Card(Card &src)
: name   (NULL)
, phone  (NULL)
, id     (0)
, book   (0)
{
   // let assignment operator do work
   (*this) = src;
}

Card :: ~Card()
{
   delete[] name;
   delete[] phone;
}

void Card :: Init(char *newname, char *newphone, int newid)
{
   if (name != NULL)
   {
      delete[] name;
      name = NULL;
   }

   name = new char [strlen(newname) + 1];
   strcpy(name, newname);

   if (phone != NULL)
   {
      delete[] phone;
      phone = NULL;
   }

   phone = new char [strlen(newphone) + 1];
   strcpy(phone, newphone);

   id = newid;
}

Card& Card :: operator=(Card &src)
{
   Init(src.name, src.phone, src.id);
   book = src.book;

   return (*this);
}

void Card :: Print(ostream &out)
{
   out << id << "(" << name << " @ " << phone << ")";
}

int Card :: GetID()
{
   return id;
}

int Card :: GetBook()
{
   return book;
}

void Card :: SetBook(int newbook)
{
   book = newbook;
}

void Card :: Write(ostream &out)
{
   out << name << endl << phone << endl
      << id << ' ' << book << endl;
}

ostream &operator<<(ostream &out, Card &src)
{
   src.Print(out);
   return (out);
}