//------------------------------------------------------------------------------
// File: circle.h
// Desc: Declaration and Definitions for 'circle' class.
//------------------------------------------------------------------------------
#ifndef _CIRCLE_H
#define _CIRCLE_H

//_[headers]____________________________________________________________________
//
#include "shape.h"			// shape base class
#include <iostream.h>		// i/o streaming (cout)

//_[circle class]_______________________________________________________________
//
// The term "circumference" is used here rather than "perimeter".
//
class circle : public shape
{
public:

	//--------------------------------------------------------------------------
	// Name: circle()
	// Desc: Constructor.
	//--------------------------------------------------------------------------
	circle(float NewRadius = 12.3)
	: Radius(NewRadius)
	{
	}

	//--------------------------------------------------------------------------
	// Name: print()
	// Desc: Displays info about circle (see comment for 'shape::print()').
	//--------------------------------------------------------------------------
	virtual print()
	{
		cout << "Circle:" << endl;
		cout << "Area of circle is " << area() << endl;
		cout << "Circumference of circle is " << circumference() << endl;
		cout << "Radius of circle is " << Radius << endl;
	}

protected:

	//--------------------------------------------------------------------------
	// Name: area()
	// Desc: Calculates the area of the circle.
	//--------------------------------------------------------------------------
	float area()
	{
		return PI * (Radius * Radius);
	}

	//--------------------------------------------------------------------------
	// Name: circumference()
	// Desc: Calculates the circumference of the circle.
	//--------------------------------------------------------------------------
	float circumference()
	{
		return 2 * PI * Radius;
	}

	//--------------------------------------------------------------------------
	// Name: Radius
	// Desc: Radius of the circle.
	//--------------------------------------------------------------------------
	float Radius;

}; // circle

#endif