//------------------------------------------------------------------------------
// File: cube.h
// Desc: Declaration and Definitions for 'cube' class.
//------------------------------------------------------------------------------
#ifndef _CUBE_H
#define _CUBE_H

//_[headers]____________________________________________________________________
//
#include "square.h"			// flat square class, used as base for cube
#include <iostream.h>		// i/o streaming (cout)

//_[cube class]_________________________________________________________________
//
class cube : public square
{
public:

	//--------------------------------------------------------------------------
	// Name: cube()
	// Desc: Constructor.
	//--------------------------------------------------------------------------
	cube(float NewSide = 10.0)
	: square(NewSide)
	{
	}

	//--------------------------------------------------------------------------
	// Name: print()
	// Desc: Displays info about cube (see comment for 'shape::print()').
	//--------------------------------------------------------------------------
	virtual print()
	{
		cout << "Cube:" << endl;
		cout << "Area of cube is " << area() << endl;
		cout << "Volume of cube is " << volume() << endl;
		cout << "Perimeter of base square is " << perimeter() << endl;
		cout << "Sides of cube are " << Side << endl;
	}

protected:

	//--------------------------------------------------------------------------
	// Name: area()
	// Desc: Calculates the area by summing up the area of all sides.  Since all
	//		sides have the same length this is as easy as multiplying the area
	//		of a single side by six (for all six sides).
	//--------------------------------------------------------------------------
	float area()
	{
		return square::area() * 6;
	}

	//--------------------------------------------------------------------------
	// Name: volume()
	// Desc: Calculates the volume of the cube.
	//--------------------------------------------------------------------------
	virtual volume()
	{
		return square::area() * Side;
	}

}; // cube

#endif