'
'
' Q-Math-Graphics (Simple QB Math Stuff)
' Neil C. Obremski (c) 1997
'
'
DECLARE SUB SetPal (setcol!, newred!, newgreen!, newblue!)
DECLARE FUNCTION RetCol! (index!, chflag!)
DECLARE SUB Pause ()
Config:
   COMMON SHARED scrheight, scrwidth, col, curscr
   DIM SHARED scrwid(15), scrhei(15), cols(15), ynflag
   scrwid(1) = 319: scrhei(1) = 199: cols(1) = 3
   scrwid(2) = 639: scrhei(2) = 199: cols(2) = 1
   scrwid(3) = 0: scrhei(3) = 0: cols(3) = 0
   scrwid(4) = 0: scrhei(4) = 0: cols(4) = 0
   scrwid(5) = 0: scrhei(5) = 0: cols(5) = 0
   scrwid(6) = 0: scrhei(6) = 0: cols(6) = 0
   scrwid(7) = 319: scrhei(7) = 199: cols(7) = 15
   scrwid(8) = 639: scrhei(8) = 199: cols(8) = 15
   scrwid(9) = 639: scrhei(9) = 319: cols(9) = 15
   scrwid(10) = 639: scrhei(10) = 319: cols(10) = 1
   scrwid(11) = 639: scrhei(11) = 479: cols(11) = 1
   scrwid(12) = 639: scrhei(12) = 479: cols(12) = 15
   scrwid(13) = 319: scrhei(13) = 199: cols(13) = 255
   coolpal = 0
  
Begin:
   GOSUB DisplayInfo

PromptScreen:
   INPUT "[X:\SCREENMODE>", curscr
   IF curscr = -7 THEN
      GOSUB DisplayInfo
      GOTO PromptScreen
   END IF
   ynflag = 1
   FOR i = 1 TO 13 STEP 1
      IF curscr = i AND scrwid(i) > 0 AND scrhei(i) > 0 THEN ynflag = 0
   NEXT i
   IF ynflag = 1 THEN
      PRINT "ERROR!  Invalid display mode, type -7 for help."
      GOTO PromptScreen
   END IF

PromptColor:
   INPUT "[X:\COLOR>", col
   IF col = -7 THEN
      GOSUB DisplayColorList
      GOTO PromptColor
   END IF
   ynflag = 1
   FOR i = 1 TO cols(curscr) STEP 1
      IF col = i THEN ynflag = 0
   NEXT i
   IF ynflag = 1 THEN
      PRINT "ERROR!  Unsupported color chosen, type -7 for color list."
      GOTO PromptColor
   END IF
   IF cols(curscr) = 255 AND col > 15 THEN coolpal = 1
     
PromptSpacing:
   INPUT "[X:\SPACING>", stpr
   IF stpr < 1 OR stpr > 75 THEN
      PRINT "ERROR!  Line spacing too little or too much, 1 to 75 only."
      GOTO PromptSpacing
   END IF

InitializeScreenVariablesAndPalette:
   SCREEN curscr
   scrwidth = scrwid(curscr)
   scrheight = scrhei(curscr)
   hadj = INT((scrwidth - scrheight) / 2)
   SELECT CASE col
      CASE 66 ' black to blue to white
         FOR i = 1 TO 191 STEP 1
            SetPal i, 0, 0, INT((191 - i) / 3)
         NEXT i
         FOR i = 192 TO 255 STEP 1
            SetPal i, 0, 0, 63
         NEXT i
      CASE 77 ' red to black
         FOR i = 1 TO 191 STEP 1
            SetPal i, INT((191 - i) / 3), 0, 0
         NEXT i
         FOR i = 192 TO 255 STEP 1
            SetPal i, 63, 0, 0
         NEXT i
      CASE 88 ' green to black
         FOR i = 1 TO 191 STEP 1
            SetPal i, 0, INT((191 - i) / 3), 0
         NEXT i
         FOR i = 192 TO 255 STEP 1
            SetPal i, 0, 63, 0
         NEXT i
      CASE 99 ' purple to black
         FOR i = 1 TO 191 STEP 1
            SetPal i, INT((191 - i) / 3), 0, INT((191 - i) / 3)
         NEXT i
         FOR i = 192 TO 255 STEP 1
            SetPal i, 63, 0, 63
         NEXT i
      CASE 111 ' cyan to black
         FOR i = 1 TO 191 STEP 1
            SetPal i, 0, INT((191 - i) / 3), INT((191 - i) / 3)
         NEXT i
         FOR i = 192 TO 255 STEP 1
            SetPal i, 0, 63, 63
         NEXT i
      CASE 122 ' yellow to black
         FOR i = 1 TO 191 STEP 1
            SetPal i, INT((191 - i) / 3), INT((191 - i) / 3), 0
         NEXT i
         FOR i = 192 TO 255 STEP 1
            SetPal i, 63, 63, 0
         NEXT i
      CASE 133 ' white to black
         FOR i = 1 TO 191 STEP 1
            SetPal i, INT((191 - i) / 3), INT((191 - i) / 3), INT((191 - i) / 3)
         NEXT i
         FOR i = 192 TO 255 STEP 1
            SetPal i, 63, 63, 63
         NEXT i
      CASE 155 ' red to green to blue
         FOR i = 1 TO 63 STEP 1
            SetPal i, i, 0, 0
         NEXT i
         FOR i = 64 TO 127 STEP 1
            SetPal i, 127 - i, i - 64, 0
         NEXT i
         FOR i = 128 TO 191 STEP 1
            SetPal i, 0, 191 - i, i - 128
         NEXT i
         FOR i = 192 TO 255 STEP 1
            SetPal i, i - 192, i - 192, 255 - i
         NEXT i
      CASE 166 ' red to blue to green
         FOR i = 1 TO 63 STEP 1
            SetPal i, i, 0, 0
         NEXT i
         FOR i = 64 TO 127 STEP 1
            SetPal i, 127 - i, 0, i - 64
         NEXT i
         FOR i = 128 TO 191 STEP 1
            SetPal i, 0, i - 128, 191 - i
         NEXT i
         FOR i = 192 TO 255 STEP 1
            SetPal i, i - 192, 255 - i, i - 192
         NEXT i
   END SELECT
DrawCurves:
   FOR i = 0 TO INT(scrheight / 2) STEP stpr
      LINE (hadj, i)-(hadj + INT(scrheight / 2) - i, 0), RetCol(i + 1, coolpal)
      LINE (hadj + scrheight, i)-(hadj + i + INT(scrheight / 2), 0), RetCol(i + 1, coolpal)
      LINE (hadj, i + INT(scrheight / 2))-(hadj + i, scrheight), RetCol(i + 1, coolpal)
      LINE (hadj + scrheight, i + INT(scrheight / 2))-(hadj + scrheight - i, scrheight), RetCol(i + 1, coolpal)
     
      LINE (hadj + i, INT(scrheight / 2))-(hadj + INT(scrheight / 2), INT(scrheight / 2) - i), RetCol(i + 1, coolpal)
      LINE (hadj + scrheight - i, INT(scrheight / 2))-(hadj + INT(scrheight / 2), INT(scrheight / 2) - i), RetCol(i + 1, coolpal)
      LINE (hadj + i, INT(scrheight / 2))-(hadj + INT(scrheight / 2), INT(scrheight / 2) + i), RetCol(i + 1, coolpal)
      LINE (hadj + scrheight - i, INT(scrheight / 2))-(hadj + INT(scrheight / 2), INT(scrheight / 2) + i), RetCol(i + 1, coolpal)
   NEXT i
   LINE (hadj + 0, 0)-(hadj + scrheight, 0), RetCol(i + 1, coolpal)
   LINE (hadj + scrheight, 0)-(hadj + scrheight, scrheight), RetCol(i + 1, coolpal)
   LINE (hadj + scrheight, scrheight)-(hadj + 0, scrheight), RetCol(i + 1, coolpal)
   LINE (hadj + INT(scrheight / 2), 0)-(hadj + INT(scrheight / 2), scrheight), RetCol(i + 1, coolpal)
   LINE (hadj + 0, scrheight)-(hadj + 0, 0), RetCol(i + 1, coolpal)
   colstep = 1
   numcol = cols(curscr)
   FOR i = 0 TO scrwidth STEP INT(scrwidth / numcol)
      FOR j = i TO i + INT(scrwidth / numcol) - 1 STEP 1
         PSET (j, 0), colstep
      NEXT j
      colstep = colstep + 1
      IF colstep > numcol THEN colstep = 0
   NEXT i

WaitForKeyPress:
   Pause

SwitchToTextMode:
   SCREEN 2
   SCREEN 0

AskForReLoop:
   INPUT "Again (Y/N)"; yn$
   IF UCASE$(yn$) = "YES" OR UCASE$(yn$) = "Y" THEN GOTO Begin
  
EndProgram:
   END

DisplayInfo:
   PRINT "ĴSimple QB Math Stuffķ"
   PRINT "  This program simply draws some simple curves using straight lines.  You   "
   PRINT " get to specify the color, the detail of the arcs (the amount of space      "
   PRINT " between each line), and the graphics mode in which to draw in.  At each    "
   PRINT " prompt please type accurate information, or you will be prompted again.    "
   PRINT "[ SCREEN MODES and DESCRIPTIONS ]Ķ"
   PRINT " ( 1) - CGA  , 320x200,   4 colors (1=Cyan, 2=Magenta, 3=White)             "
   PRINT " ( 2) - MONO , 640x200,   2 colors (1=White)                                "
   PRINT " ( 7) - EGA  , 320x200,  16 colors (see BASIC COLOR LIST)                   "
   PRINT " ( 8) - EGA  , 640x200,  16 colors (see BASIC COLOR LIST)                   "
   PRINT " ( 9) - VGA  , 640x350,  16 colors (see BASIC COLOR LIST)                   "
   PRINT " (10) - VGA  , 640x350,   2 colors (1=White)                                "
   PRINT " (11) - VGA  , 640x480,   2 colors (1=White)                                "
   PRINT " (12) - VGA  , 640x480,  16 colors (see BASIC COLOR LIST)                   "
   PRINT " (13) - VGA  , 320x200, 256 colors (see ADVANCED COLOR LIST)                "
   PRINT "                                                                          "
   PRINT "ĴBy Neil C. Obremski, (C)opyright 1997Ľ"
   PRINT "                                                                            "
   RETURN

DisplayColorList:
   IF cols(curscr) = 255 THEN
         PRINT "<*>------ ----- ---- --- -- ADVANCED  COLOR LISTING -- --- ---- ----- ------<*>"
         PRINT " * The display mode you have chosen supports 256 colors.  This means you can *"
         PRINT " * choose one of the basic colors as listed below or you can type one of the *"
         PRINT " * following to get some cool effects:                                       *"
         PRINT " * ( 66) = Blue-Black                     ( 77) = Red-Black                  *"
         PRINT " * ( 88) = Green-Black                    ( 99) = Purple-Black               *"
         PRINT " * (111) = Cyan-Black                     (122) = Yellow-Black               *"
         PRINT " * (133) = White-Black                    (144) = Stand 256                  *"
         PRINT " * (155) = Red-Green-Blue                 (166) = Red-Blue-Green             *"
         PRINT " * (177) = White-Black                    (188) = Stand 256                  *"
   END IF
   SELECT CASE cols(curscr)
      CASE 1
         PRINT "1 = White"
      CASE 3
         PRINT "1 = Cyan"
         PRINT "2 = Magenta"
         PRINT "3 = White"
      CASE 15, 255
         PRINT "<*>------ ----- ---- --- -- - BASIC COLOR LISTING - -- --- ---- ----- ------<*>"
         PRINT " * 01 = Blue                                 09 = Light Blue                 * "
         PRINT " * 02 = Green                                10 = Light Green                * "
         PRINT " * 03 = Cyan                                 11 = Bright Cyan                * "
         PRINT " * 04 = Red                                  12 = Light Red                  * "
         PRINT " * 05 = Purple                               13 = Light Purple (Pink)        * "
         PRINT " * 06 = Brown/Orange                         14 = Yellow                     * "
         PRINT " * 07 = White                                15 = Bright White               * "
         PRINT " * 08 = Gray                                                                 * "
         PRINT "<*>------ ----- ---- --- -- - . .. ... _ ... .. . - -- --- ---- ----- ------<*>"
   END SELECT
   RETURN

SUB Pause
        DO
        LOOP WHILE INKEY$ = ""
END SUB

FUNCTION RetCol (index, chflag)
   IF chflag = 1 THEN
      RetCol = index MOD cols(curscr)
   ELSE
      RetCol = col
   END IF
END FUNCTION

SUB SetPal (setcol, newred, newgreen, newblue)
   IF (setcol > -1 AND setcol < cols(curscr)) THEN
      PALETTE setcol, newblue * 65536 + newgreen * 256 + newred
   END IF
END SUB

