//------------------------------------------------------------------------------
// File: square.h
// Desc: Declaration and Definitions for 'square' class.
//------------------------------------------------------------------------------
#ifndef _SQUARE_H
#define _SQUARE_H

//_[headers]____________________________________________________________________
//
#include "shape.h"			// shape base class
#include <iostream.h>		// i/o streaming (cout)

//_[square class]_______________________________________________________________
//
class square : public shape
{
public:

	//--------------------------------------------------------------------------
	// Name: square()
	// Desc: Constructor.
	//--------------------------------------------------------------------------
	square(float NewSide = 10.0)
	: Side	(NewSide)
	{
	}

	//--------------------------------------------------------------------------
	// Name: print()
	// Desc: Displays info about square (see comment for 'shape::print()').
	//--------------------------------------------------------------------------
	virtual print()
	{
		cout << "Square:" << endl;
		cout << "Area of square is " << area() << endl;
		cout << "Perimeter square is " << perimeter() << endl;
		cout << "Sides of square are " << Side << endl;
	}

protected:

	//--------------------------------------------------------------------------
	// Name: area()
	// Desc: Calculates area of square (length of side squared).
	//--------------------------------------------------------------------------
	float area()
	{
		return Side * Side;
	}

	//--------------------------------------------------------------------------
	// Name: perimeter()
	// Desc: Calculates perimeter of square (sum of all sides).
	//--------------------------------------------------------------------------
	float perimeter()
	{
		return Side * 4;
	}

	//--------------------------------------------------------------------------
	// Name: Side
	// Desc: Single side of square.
	//--------------------------------------------------------------------------
	float Side;

}; // square

#endif