/*****************************************************************************

	[customer.h] Customer class definition
	By Julio Arias

*****************************************************************************/

#include <iostream>
#include <stdlib.h>				// for srand(), rand()
#include <time.h>				// for time()

class Customer
{
public:
	Customer();
	~Customer();

	void reset(long iTime);						// reset for new customer
	long getNum() const		{ return iNum; }	// return my number
	long getArrival() const	{ return iArr; }	// return my arrival time

private:
	long	iNum,		// my number
			iArr;		// my arrival time
	static long iCustomerNum;
};

//_[Customer::iCustomerNum]___________________________________________________
//
// DESCRIPTION:
//  Static number to keep track of the number of Customer objects created.
//
long Customer::iCustomerNum = 0;

//_[Customer::Customer()]_____________________________________________________
//
// DESCRIPTION:
//  Default constructor.
//
Customer::Customer()
{
	reset(0);
}

//_[Customer::~Customer()]____________________________________________________
//
// DESCRIPTION:
//  Destructor
//
Customer::~Customer()
{
}

//_[Customer::reset()]________________________________________________________
//
// DESCRIPTION:
//  Sets the customer's number and arrival time.
//
void Customer::reset(long iTime)
{
	//_[seed random number generator with current time on first customer]_____
	if (!iCustomerNum)
		srand(time(NULL));

	iNum	= iCustomerNum++;
	iArr	= iTime;
}

//_[<<(ostream,Customer)]_____________________________________________________
//
// DESCRIPTION:
//  Small function to allow using the Customer object in output streams, like
//  'cout'.
//
ostream &operator<<(ostream &os, Customer &c)
{
	return (os << "Customer #" << c.getNum());
}
