/*****************************************************************************

	[listnd.h] ListNode template definition
	By Julio Arias

*****************************************************************************/
#ifndef LISTND_H
#define LISTND_H

template< class NODETYPE > class List;	// forward declaration

//_[ListNode class]___________________________________________________________
//
//
template<class NODETYPE>
class ListNode {
	friend class List< NODETYPE >;	// make List a friend
public:
	ListNode( const NODETYPE & );	// constructor
	NODETYPE getData() const;		// return data in the node
private:
	NODETYPE data;					// data
	ListNode< NODETYPE > *nextPtr;	// next node in the list
};

//_[ListNode::ListNode()]_____________________________________________________
//
// DESCRIPTION:
//  Constructor
//
template<class NODETYPE>
ListNode< NODETYPE >::ListNode( const NODETYPE &info )
	: data( info), nextPtr( 0 ) { }

//_[ListNode::getData()]______________________________________________________
//
// DESCRIPTION:
//  Return a copy of the data in the node
//
template< class NODETYPE >
NODETYPE ListNode< NODETYPE >::getData() const { return data; }

#endif