/*****************************************************************************

	[queue.h] Queue class template definition
	By Julio Arias

*****************************************************************************/
#ifndef QUEUE_H
#define QUEUE_H

#include "list.h"

template< class QUEUETYPE >
class Queue: private List< QUEUETYPE > {
public:
	void enqueue( const QUEUETYPE &d ) { insertAtBack( d ); }
	bool dequeue( QUEUETYPE &d )
		{ return removeFromFront( d ); }
	bool isQueueEmpty() const { return isEmpty(); }
	void printQueue() const { print(); }
	long count() const { return List<QUEUETYPE>::count(); }
	bool isEmpty() const { return List<QUEUETYPE>::isEmpty(); }
	QUEUETYPE &top() const { return List<QUEUETYPE>::top(); }
};

#endif