// File:  words.cc
//
// General outline for program 2 - Word
// Concordance.

// libraries needed:
#include<iostream.h>
#include<fstream.h>
#include<string.h>
#include<stdlib.h>

// include our header
#include"words.h"

int main() {
  WordNode *WordList = NULL;
  char *Word;
  ifstream InputFile;
  int TrivialCount;
  int Location;

  // get name and open input file
  InitFile( InputFile );

  // loop through all words in file
  while( (Word = GetWord( InputFile, Location ) ) != NULL )
    ProcessWord( WordList, Word, Location );

  // display concordance
  cout << endl << "Concordance of all words:" << endl;
  DisplayList( WordList );

  // remove trivial words
  RemoveTrivials( WordList, TrivialCount );
  cout << endl << "Removed " << TrivialCount << " trivial words" << endl;

  // display concordance without trivials
  cout << endl << "Concordance without trivial words:" << endl;
  DisplayList( WordList );

  // destroy the list
  DestroyList( WordList );

  // close InputFile file
  InputFile.close();

  // return success
  return 0;
}

