// Here is the header file for the Word Concordance
// Program
#ifndef Words_H
#define Words_H

// Constants:
const int MAX_LINE_LENGTH = 100;

// LocNode type:
struct LocNode {
  int location;
  LocNode *next;
};

// WordNode type:
struct WordNode {
   char *word;
   int  freq;
   WordNode *next;
   LocNode *loc;    // locations list
};

// prototypes for
// Related User-defined functions:
void InitFile( ifstream &input );
char* GetWord( ifstream &input, int &location );
void ProcessWord( WordNode *&list, char *word, int location );
WordNode* LookupWord( WordNode *list, char *word );
WordNode* MakeNewNode(char *word);
void AddAtBeginning( WordNode *&first, char *word, int location );
void AddAtEnd( WordNode *last, char *word, int location );
void AddInMiddle(WordNode *here, char *word, int location );
void DisplayList( WordNode *list );
void RemoveFirst( WordNode *&node );
WordNode* Remove( WordNode *&list, char *word );
void RemoveTrivials( WordNode *&list, int &count );
void AddLoc( WordNode *node, int location );
LocNode* MakeNewLocNode( int location );
void DestroyList( WordNode *&list );
void RemoveLocList( WordNode *node );

#endif
